unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, DB, Forms, Controls, Graphics, Dialogs, StdCtrls, ComCtrls, DBGrids, Spin, ZConnection, ZDataset;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    ComboBox1: TComboBox;
    conn: TZConnection;
    DataSource1: TDataSource;
    DataSource2: TDataSource;
    DBGrid1: TDBGrid;
    DBGrid2: TDBGrid;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Memo1: TMemo;
    PageControl1: TPageControl;
    query1: TZQuery;
    query2: TZQuery;
    SpinEdit1: TSpinEdit;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
var
  sl: TStringList;
begin
  conn.Protocol := 'OleDB';
  conn.HostName := edit1.Text;
  conn.Database := Format('Provider=MSOLEDBSQL.1;Data Source=%s;Initial Catalog=%s;User ID=%s;PWD=%s;', [edit1.Text, edit2.Text, edit3.Text, edit4.Text]);
  conn.User := edit3.Text;
  conn.Password := edit4.Text;
  try
    conn.Connect;
  except
    on E: Exception do
      ShowMessage('MSSQL Connection Error: ' + #13#10 + E.Message);
  end;
  Button1.Enabled := not conn.Connected;
  PageControl1.Enabled := conn.Connected;
  //get all tables
  if conn.Connected then
  begin
    sl := TStringList.Create;
    sl.CaseSensitive := False;
    conn.GetTableNames('', sl);
    sl.Sort;
    ComboBox1.Items.Assign(sl);
    sl.Free;
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  s: String;
begin
  if ComboBox1.ItemIndex >= 0 then
  begin
    if query1.Active then
      query1.Close;
    if SpinEdit1.Value > 0 then
      s := ' top ' + IntToStr(SpinEdit1.Value) + ' '
    else
      s := '';
    query1.SQL.Text := ' select ' + s + ' * from ' + ComboBox1.Text;
    query1.Open;
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  Label8.Caption := '';
  if query2.Active then
    query2.Close;
  try
    query2.SQL.Assign(memo1.Lines);
    query2.Open;
  except
    on E: Exception do
      ShowMessage('SELECT Error: ' + E.Message);
  end;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  Label8.Caption := '';
  if query2.Active then
    query2.Close;
  try
    query2.SQL.Assign(memo1.Lines);
    query2.ExecSQL;
    Label8.Caption := IntToStr(query2.RowsAffected);
  except
    on E: Exception do
      ShowMessage('UPDATE/INSERT/DELETE Error: ' + E.Message);
  end;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  Label8.Caption := '';
  Button1.Enabled := not conn.Connected;
  PageControl1.Enabled := conn.Connected;
end;

end.

